#<profile4xi profile = "33"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "__init__.py">
#<abstract4xi abstract = "Multiprocessing4Xi"/>
#<refer4xi reference = "threading.py"/>
#<note4xi note = "Processes instead of threads are being used for multi-core processors"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------



# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Process', 'current_process', 'active_children', 'freeze_support',                        # Multiprocessing
    'Manager', 'Pipe', 'cpu_count', 'log_to_stderr', 'get_logger',
    'allow_connection_pickling', 'BufferTooShort', 'TimeoutError',
    'Lock', 'RLock', 'Semaphore', 'BoundedSemaphore', 'Condition',
    'Event', 'Queue', 'JoinableQueue', 'Pool', 'Value', 'Array',
    'RawValue', 'RawArray',
    'Process2Xi', 'current_process2xi', 'active_children2xi', 'freeze_support2xi',                    # Multiprocessing2Xi
    'Manager2Xi', 'Pipe2Xi', 'cpu_corecount2xi', 'log_to_stderr2xi', 'get_logger2xi',
    'allow_connection_pickling2xi', 'BufferTooShort2Xi', 'TimeoutError2Xi',
    'Lock2Xi', 'RLock2Xi', 'Semaphore2Xi', 'BoundedSemaphore2Xi', 'Condition2Xi',
    'Event2Xi', 'Queue2Xi', 'JoinableQueue2Xi', 'Pool2Xi', 'ValueFunction2Xi', 'ArrayFunction2Xi',
    'RawValue2Xi', 'RawArray2Xi',    
    'Process4Xi', 'current_process4xi', 'active_children4xi', 'freeze_support4xi',                    # Multiprocessing4Xi
    'Manager4Xi', 'Pipe4Xi', 'cpu_corecount4xi', 'log_to_stderr4xi', 'get_logger4xi',
    'allow_connection_pickling4xi', 'BufferTooShort4Xi', 'TimeoutError4Xi',
    'Lock4Xi', 'RLock4Xi', 'Semaphore4Xi', 'BoundedSemaphore4Xi', 'Condition4Xi',
    'Event4Xi', 'Queue4Xi', 'JoinableQueue4Xi', 'Pool4Xi', 'ValueFunction4Xi', 'ArrayFunction4Xi',
    'RawValue4Xi', 'RawArray4Xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # most-common ones
    pass         
except:
    pass
try:                 # rare ones
    pass          
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.process import active_children
    from multiprocessing.process import current_process
    from multiprocessing.process import Process
except:
    pass
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from active_children2xi import active_children2xi
from current_process2xi import current_process2xi
from process2xi import Process2Xi
from time2xi import time2xi

from active_children4xi import active_children4xi
from current_process4xi import CurrentProcess4Xi
from print4xi import print4xi
from process4xi import Process4Xi
from time4xi import time4xi
#"
#/>


# =================================================================================================
# Exceptions
# =================================================================================================

                               
# -------------------------------------------------------------------------------------------------
#<class4xi class = "ProcessError" base = "Exception" child = "None" synopsis = "Process Error" usage = "
#   Exception"
#>
# -------------------------------------------------------------------------------------------------
class ProcessError(Exception):
    pass
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<class4xi class = "ProcessError2Xi" base = "Exception" child = "None" synopsis = "Process Error" usage = "
#   Exception"
#>
# -------------------------------------------------------------------------------------------------
class ProcessError2Xi(Exception):
    pass
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<class4xi class = "ProcessError4Xi" base = "Exception" child = "None" synopsis = "Process Error" usage = "
#   Exception"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
class ProcessError4Xi(Exception):
    pass        
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<class4xi class = "BufferTooShort" base = "ProcessError" child = "None" synopsis = "Buffer Too Short" usage = "
#   Exception"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------  
class BufferTooShort(ProcessError):
    pass
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<class4xi class = "BufferTooShort2Xi" base = "ProcessError2Xi" child = "None" synopsis = "Buffer Too Short" usage = "
#   Exception"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ------------------------------------------------------------------------------------------------- 
class BufferTooShort2Xi(ProcessError2Xi):
    pass
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<class4xi class = "BufferTooShort4Xi" base = "ProcessError4Xi" child = "None" synopsis = "Buffer Too Short" usage = "
#   Exception"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------     
class BufferTooShort4Xi(ProcessError4Xi):
    pass        
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<class4xi class = "TimeoutError" base = "ProcessError" child = "None" synopsis = "Timeout Error" usage = "
#   Exception"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
class TimeoutError(ProcessError):
    pass
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<class4xi class = "TimeoutError2Xi" base = "ProcessError2Xi" child = "None" synopsis = "Timeout Error" usage = "
#   Exception"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
class TimeoutError2Xi(ProcessError2Xi):
    pass
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<class4xi class = "TimeoutError4Xi" base = "ProcessError4Xi" child = "None" synopsis = "Timeout Error" usage = "
#   Exception"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------        
class TimeoutError4Xi(ProcessError4Xi):
    pass
#</class4xi>

     
    
        
# -------------------------------------------------------------------------------------------------
#<class4xi class = "AuthenticationError" base = "ProcessError" child = "None" synopsis = "Authentication Error" usage = "
#   Exception"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
class AuthenticationError(ProcessError):
    pass
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<class4xi class = "AuthenticationError2Xi" base = "ProcessError2Xi" child = "None" synopsis = "Authentication Error" usage = "
#   Exception"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
class AuthenticationError2Xi(ProcessError2Xi):
    pass
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<class4xi class = "AuthenticationError4Xi" base = "ProcessError4Xi" child = "None" synopsis = "Authentication Error" usage = "
#   Exception"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
class AuthenticationError4Xi(ProcessError4Xi):
    pass
#</class4xi>

     
        
# =================================================================================================
# Definitions not depending on native semaphores
# =================================================================================================


# -------------------------------------------------------------------------------------------------
#<function4xi function = "Manager" usage = "
#   Returns a manager associated with a running server process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def Manager():
    '''
    Returns a manager associated with a running server process

    The managers methods such as `Lock()`, `Condition()` and `Queue()`
    can be used to create shared objects.
    '''
    from multiprocessing.managers import SyncManager    
    
    m = SyncManager()
    m.start()
    return m
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "Manager2Xi" usage = "
#   Returns a manager associated with a running server process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def Manager2Xi():
    '''
    Returns a manager associated with a running server process

    The managers methods such as `Lock()`, `Condition()` and `Queue()`
    can be used to create shared objects.
    '''
    from syncmanager2xi import SyncManager    
    
    m2xi = SyncManager2Xi()
    m2xi.start()
    return m2xi
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "Manager4Xi" usage = "
#   returns a manager associated with a running server process
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def Manager4Xi():
    '''
    Manager4Xi function returns a manager associated with a running server process

    The managers methods such as `Lock()`, `Condition()` and `Queue()`
    can be used to create shared objects.
    '''
    from syncmanager4xi import SyncManager4Xi    
    
    class2print = "Manager4Xi"
    method2print = "Manager4Xi"
    
    message2print = "{started" + "; Manager4Xi-started: " + str(Manager4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     

    # ---------------------------------------------------------------------------------------------        
    # Solution
    # + is compatible with the common multiprocessing
    # - new dragonized proxies and type are not registered
    # ---------------------------------------------------------------------------------------------
    # The code is separated to this module.
    # The original Manager function in ___init__.py is called     
    # SyncManager class                              
    #
    # called when the multiprocessing package is initialized
    # __init__.py:
    #
    #     def Manager():
    #         from multiprocessing.managers import SyncManager <--- uses managers.py class SyncManager
    #         m = SyncManager()
    #         m.start()
    # --------------------------------------------------------------------------------------------- 
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
         
    manager2xi = SyncManager4Xi()
    
    message2print = "{created" + "; manager2xi-created-by-Manager4Xi: " + str(manager2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)     
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
        
       
    manager2xi.start()
    
    message2print = "{started" + "; manager2xi-start-started: " + str(manager2xi.start)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)       
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    
    message2print = "{(Step 5/5) returning" + "; manager2xi-returning-by-Manager4X: " + str(manager2xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)   
    
    return m4xi
#</function4xi>
 
    
    
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Pipe" usage = "
#   Returns two connection object connected by a pipe
#"> 
# -------------------------------------------------------------------------------------------------
def Pipe(duplex=True):
    '''
    Returns two connection object connected by a pipe
    '''
    from multiprocessing.connection import Pipe    
    return Pipe(duplex)
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "Pipe2Xi" usage = "
#   Returns two connection object connected by a pipe
#"> 
# -------------------------------------------------------------------------------------------------
def Pipe2Xi(duplex=True):
    '''
    Returns two connection object connected by a pipe
    '''
    from pipe2xi import Pipe2Xi
    return Pipe2Xi(duplex)        
#</function4xi>
    
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Pipe4Xi" usage = "
#   Returns two connection object connected by a pipe
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def Pipe4Xi(duplex=True):
    '''
    Returns two connection object connected by a pipe
    '''
    from pipe4xi import Pipe4Xi
    return Pipe4Xi(duplex)    
#</function4xi>
    
    
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "cpu_count" usage = "
#   Returns the number of CPUs in the system
#"> 
# -------------------------------------------------------------------------------------------------
def cpu_count():
    '''
    Returns the number of CPUs in the system
    '''
    if sys.platform == 'win32':
        try:
            num = int(os.environ['NUMBER_OF_PROCESSORS'])
        except (ValueError, KeyError):
            num = 0
    elif sys.platform == 'darwin':
        try:
            num = int(os.popen('sysctl -n hw.ncpu').read())
        except ValueError:
            num = 0
    else:
        try:
            num = os.sysconf('SC_NPROCESSORS_ONLN')
        except (ValueError, OSError, AttributeError):
            num = 0

    if num >= 1:
        return num
    else:
        raise NotImplementedError('cannot determine number of cpus')
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "cpu_corecount2xi" usage = "
#   returns the number of CPUs in the system
#"> 
# -------------------------------------------------------------------------------------------------
def cpu_corecount2xi():
    '''
    returns the number of CPUs in the system
    '''
    from cpu_corecount2xi import cpu_corecount2xi
    return cpu_corecount2xi()      
#</function4xi>
        
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "cpu_corecount4x" usage = "
#   returns the number of CPUs in the system
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def cpu_corecount4xi():
    '''
    returns the number of CPUs in the system
    '''
    from cpu_corecount4xi import cpu_corecount4xi
    return cpu_corecount4xi()        
#</function4xi>
        
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "freeze_support" usage = "
#   Check whether this is a fake forked process in a frozen executable
#"> 
# -------------------------------------------------------------------------------------------------
def freeze_support():
    '''
    Check whether this is a fake forked process in a frozen executable.
    If so then run code specified by commandline and exit.
    '''
    if sys.platform == 'win32' and getattr(sys, 'frozen', False):
        from multiprocessing.forking import freeze_support
        freeze_support()
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "freeze_support2xi" usage = "
#   Check whether this is a fake forked process in a frozen executable
#"> 
# -------------------------------------------------------------------------------------------------
def freeze_support2xi():
    '''
    Check whether this is a fake forked process in a frozen executable.
    If so then run code specified by commandline and exit.
    '''
    freeze_support()            
#</function4xi>
        
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "freeze_support4xi" usage = "
#   Check whether this is a fake forked process in a frozen executable.
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def freeze_support4xi():
    '''
    Check whether this is a fake forked process in a frozen executable.
    If so then run code specified by commandline and exit.
    '''
    freeze_support()        
#</function4xi>
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get_logger" usage = "
#   Return package logger -- if it does not already exist then it is created
#"> 
# -------------------------------------------------------------------------------------------------
def get_logger():
    '''
    Return package logger -- if it does not already exist then it is created
    '''
    from multiprocessing.util import get_logger    
    return get_logger()
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get_logger2xi" usage = "
#   Return package logger -- if it does not already exist then it is created
#"> 
# -------------------------------------------------------------------------------------------------
def get_logger2xi():
    '''
    Return package logger -- if it does not already exist then it is created
    '''
    from get_logger2xi import get_logger2xi    
    return get_logger2xi()        
#</function4xi>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "get_logger4xi" usage = "
#   Return package logger -- if it does not already exist then it is created
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def get_logger4xi():
    '''
    Return package logger -- if it does not already exist then it is created
    '''
    from get_logger4xi import get_logger4xi    
    return get_logger4xi()    
#</function4xi>
    
        
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "log_to_stderr" usage = "
#   Turn on logging and add a handler which prints to stderr
#"> 
# -------------------------------------------------------------------------------------------------
def log_to_stderr(level=None):
    '''
    Turn on logging and add a handler which prints to stderr
    '''
    from multiprocessing.util import log_to_stderr    
    return log_to_stderr(level)
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "log_to_stderr2xi" usage = "
#   Turn on logging and add a handler which prints to stderr
#"> 
# -------------------------------------------------------------------------------------------------
def log_to_stderr2xi(level=None):
    '''
    Turn on logging and add a handler which prints to stderr
    '''
    from log_to_stderr2xi import log_to_stderr2xi    
    return log_to_stderr2xi(level)    
#</function4xi>
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "log_to_stderr4xi" usage = "
#   Turn on logging and add a handler which prints to stderr
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def log_to_stderr4xi(level=None):
    '''
    Turn on logging and add a handler which prints to stderr
    '''
    from log_to_stderr4xi import log_to_stderr4xi    
    return log_to_stderr4xi(level)
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "allow_connection_pickling" usage = "
#   Install support for sending connections and sockets between processes
#"> 
# -------------------------------------------------------------------------------------------------
def allow_connection_pickling():
    '''
    Install support for sending connections and sockets between processes
    '''
    from multiprocessing import reduction
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "allow_connection_pickling2xi" usage = "
#   Install support for sending connections and sockets between processes
#"> 
# -------------------------------------------------------------------------------------------------
def allow_connection_pickling2xi():
    '''
    Install support for sending connections and sockets between processes
    '''
 
    allow_connection_pickling()    
#</function4xi>
    
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "allow_connection_pickling4xi" usage = "
#   Install support for sending connections and sockets between processes
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def allow_connection_pickling4xi():
    '''
    Install support for sending connections and sockets between processes
    '''
 
    allow_connection_pickling()
#</function4xi>
    
    
                             
# =================================================================================================
#
# Definitions depending on native semaphores
#
# =================================================================================================
                               
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Lock" usage = "
#   Returns a non-recursive lock object
#"> 
# -------------------------------------------------------------------------------------------------
def Lock():
    '''
    Returns a non-recursive lock object
    '''
    from multiprocessing.synchronize import Lock
    return Lock()
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "Lock2Xi" usage = "
#   Returns a non-recursive lock object
#"> 
# -------------------------------------------------------------------------------------------------
def Lock2Xi():
    '''
    Returns a non-recursive lock object
    '''
    from lock2xi import Lock2Xi
    return Lock2Xi()        
#</function4xi>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Lock4Xi" usage = "
#   Returns a non-recursive lock object
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def Lock4Xi():
    '''
    Returns a non-recursive lock object
    '''
    from lock4xi import Lock4Xi
    return Lock4Xi()    
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "RLock" usage = "
#   Returns a recursive lock object
#">                            
# -------------------------------------------------------------------------------------------------
def RLock():
    '''
    Returns a recursive lock object
    '''
    from multiprocessing.synchronize import RLock
    return RLock()        
#</function4xi>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "RLock2Xi" usage = "
#   Returns a recursive lock object
#">                         
# -------------------------------------------------------------------------------------------------
def RLock2Xi():
    '''
    Returns a recursive lock object
    '''
    from rlock2xi import RLock2Xi
    return RLock2Xi()
#</function4xi>
    
            
# -------------------------------------------------------------------------------------------------
#<function4xi function = "RLock4Xi" usage = "
#   Returns a recursive lock object
#">                            
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def RLock4Xi():
    '''
    Returns a recursive lock object
    '''
    from rlock4xi import RLock4Xi
    return RLock4Xi()
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "Condition" usage = "
#   Returns a condition object
#">                            
# -------------------------------------------------------------------------------------------------
def Condition(lock=None):
    '''
    Returns a condition object
    '''
    from multiprocessing.synchronize import Condition
    return Condition(lock)        
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "Condition2X" usage = "
#   Returns a condition object
#">                            
# -------------------------------------------------------------------------------------------------
def Condition2Xi(lock=None):
    '''
    Returns a condition object
    '''
    from condition2xi import Condition2Xi
    return Condition2Xi(lock)
#</function4xi>
            
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Condition4Xi" usage = "
#   Returns a condition object
#">                           
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def Condition4Xi(lock=None):
    '''
    Returns a condition object
    '''
    from condition4xi import Condition4Xi
    return Condition4Xi(lock)
#</function4xi>

  
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Semaphore" usage = "
#   Returns a semaphore object
#">                           
# -------------------------------------------------------------------------------------------------
def Semaphore(value=1):
    '''
    Returns a semaphore object
    '''
    from multiprocessing.synchronize import Semaphore    
    return Semaphore(valu)    
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "Semaphore2Xi" usage = "
#   Returns a semaphore object
#">                             
# -------------------------------------------------------------------------------------------------
def Semaphore2Xi(value=1):
    '''
    Returns a semaphore object
    '''
    from semaphore2xi import Semaphore2Xi
    return Semaphore2Xi(value)    
#</function4xi>
    
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Semaphore4Xi" usage = "
#   Returns a semaphore object
#">                        
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def Semaphore4Xi(value=1):
    '''
    Returns a semaphore object
    '''
    from semaphore4xi import Semaphore4Xi
    return Semaphore4Xi(value)
#</function4xi>
        
    
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "BoundedSemaphore" usage = "
#   Returns a bounded semaphore object
#">                       
# -------------------------------------------------------------------------------------------------
def BoundedSemaphore(value=1):
    '''
    Returns a bounded semaphore object
    '''
    from multiprocessing.synchronize import BoundedSemaphore
    return BoundedSemaphore(value)
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "BoundedSemaphore2Xi" usage = "
#   Returns a bounded semaphore object
#">                         
# -------------------------------------------------------------------------------------------------
def BoundedSemaphore2Xi(value=1):
    '''
    Returns a bounded semaphore object
    '''
    from boundedsemaphore2xi import BoundedSemaphore2Xi
    return BoundedSemaphore2Xi(value)    
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "BoundedSemaphore4Xi" usage = "
#   Returns a bounded semaphore object
#">                             
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def BoundedSemaphore4Xi(value=1):
    '''
    Returns a bounded semaphore object
    '''
    from boundedsemaphore4xi import BoundedSemaphore4Xi
    return BoundedSemaphore4Xi(value)       
#</function4xi>
    
        
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Event" usage = "
#   Returns an event object
#">                                
# -------------------------------------------------------------------------------------------------
def Event():
    '''
    Returns an event object
    '''
    from multiprocessing.synchronize import Event
    return Event()
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "Event2Xi" usage = "
#   Returns an event object
#">                                
# -------------------------------------------------------------------------------------------------
def Event2Xi():
    '''
    Returns an event object
    '''
    from event2xi import Event2Xi
    return Event2Xi()    
#</function4xi>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Event4Xi" usage = "
#   Returns an event object
#">                                
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def Event4Xi():
    '''
    Returns an event object
    '''
    from event4xi import Event4Xi
    return Event4Xi()      
#</function4xi>
    
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Queue" usage = "
#   Returns a queue object
#">                                
# -------------------------------------------------------------------------------------------------
def Queue(maxsize=0):
    '''
    Returns a queue object
    '''
    from multiprocessing.queues import Queue
    return Queue(maxsize)
#</function4xi>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Queue2Xi" usage = "
#   Returns a queue object
#">                                
# -------------------------------------------------------------------------------------------------
def Queue2Xi(maxsize=0):
    '''
    Returns a queue object
    '''
    from queue2xi import Queue2Xi
    return Queue2Xi(maxsize)    
#</function4xi>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Queue4Xi" usage = "
#   Returns a queue object
#">                                
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def Queue4Xi(maxsize=0):
    '''
    Returns a queue object
    '''
    from queue4xi import Queue4Xi
    return Queue4Xi(maxsize)    
#</function4xi>
    
    
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "JoinableQueue" usage = "
#   Returns a queue object
#">                                
# -------------------------------------------------------------------------------------------------
def JoinableQueue(maxsize=0):
    '''
    Returns a queue object
    '''
    from multiprocessing.queues import JoinableQueue

    return JoinableQueue(maxsize)
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "JoinableQueue2Xi" usage = "
#   Returns a queue object
#">                                
# -------------------------------------------------------------------------------------------------
def JoinableQueue2Xi(maxsize=0):
    '''
    Returns a queue object
    '''
    from joinablequeue2xi import JoinableQueue2Xi
    return JoinableQueue2Xi(maxsize)    
#</function4xi>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "JoinableQueue4Xi" usage = "
#   Returns a queue object
#">                                
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def JoinableQueue4Xi(maxsize=0):
    '''
    Returns a queue object
    '''
    from joinablequeue4xi import JoinableQueue4Xi
    return JoinableQueue4Xi(maxsize)       
#</function4xi>
    
    
   
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Pool" usage = "
#   Returns a process pool object
#">                                
# -------------------------------------------------------------------------------------------------
def Pool(processes=None, initializer=None, initargs=()):
    '''
    Returns a process pool object
    '''
    from multiprocessing.pool import Pool
    return Pool(processes, initializer, initargs)
#</function4xi>

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Pool2Xi" usage = "
#   Returns a process pool object
#">                                
# -------------------------------------------------------------------------------------------------
def Pool2Xi(processes=None, initializer=None, initargs=()):
    '''
    Returns a process pool object
    '''
    from pool2xi import Pool2Xi
    return Pool2Xi(processes, initializer, initargs)
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Pool4Xi" usage = "
#   Returns a process pool object
#">                                
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def Pool4Xi(processes=None, initializer=None, initargs=()):
    '''
    Returns a process pool object
    '''
    from pool4xi import Pool4Xi
    return Pool4Xi(processes, initializer, initargs)    
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "RawValue" usage = "
#   Returns a shared object
#">                                
# -------------------------------------------------------------------------------------------------
def RawValue(typecode_or_type, *args):
    '''
    Returns a shared object
    '''
    from multiprocessing.sharedctypes import RawValue
    return RawValue(typecode_or_type, *args)
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "RawValue2Xi" usage = "
#   Returns a shared object
#">                                
# -------------------------------------------------------------------------------------------------
def RawValue2Xi(typecode_or_type, *args):
    '''
    Returns a shared object
    '''
    from rawvalue2xi import RawValue2Xi
    return RawValue2Xi(typecode_or_type, *args)    
#</function4xi>

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "RawValue4Xi" usage = "
#   Returns a shared object
#">                                
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def RawValue4Xi(typecode_or_type, *args):
    '''
    Returns a shared object
    '''
    from rawvalue4xi import RawValue4Xi
    return RawValue4Xi(typecode_or_type, *args)    
#</function4xi>

    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "RawArray" usage = "
#   Returns a shared array
#">                                
# -------------------------------------------------------------------------------------------------
def RawArray(typecode_or_type, size_or_initializer):
    '''
    Returns a shared array
    '''
    from multiprocessing.sharedctypes import RawArray
    return RawArray(typecode_or_type, size_or_initializer)
#</function4xi>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "RawArray2Xi" usage = "
#   Returns a shared array
#">                                
# -------------------------------------------------------------------------------------------------
def RawArray2Xi(typecode_or_type, size_or_initializer):
    '''
    Returns a shared array
    '''
    from rawarray2xi import RawArray2Xi
    return RawArray2Xi(typecode_or_type, size_or_initializer)    
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "RawArray2Xi" usage = "
#   Returns a shared array
#">                                
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def RawArray4Xi(typecode_or_type, size_or_initializer):
    '''
    Returns a shared array
    '''
    from rawarray4xi import RawArray4Xi
    return RawArray4Xi(typecode_or_type, size_or_initializer)    
#</function4xi>    
    
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Value" usage = "
#   Returns a synchronized shared object
#">                                
# -------------------------------------------------------------------------------------------------
def Value(typecode_or_type, *args, **kwds):
    '''
    Returns a synchronized shared object
    '''
    from multiprocessing.sharedctypes import Value
    return Value(typecode_or_type, *args, **kwds)
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "ValueFunction2Xi" usage = "
#   Returns a synchronized shared object
#">                                
# -------------------------------------------------------------------------------------------------
def ValueFunction2Xi(typecode_or_type, *args, **kwds):
    '''
    Returns a synchronized shared object
    '''
    from valuefunction2xi import ValueFunction2Xi
    return ValueFunction2Xi(typecode_or_type, *args, **kwds)    
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "ValueFunction4Xi" usage = "
#   Returns a synchronized shared object
#">                                
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def ValueFunction4Xi(typecode_or_type, *args, **kwds):
    '''
    Returns a synchronized shared object
    '''
    from valuefunction4xi import ValueFunction4Xi
    return ValueFunction4Xi(typecode_or_type, *args, **kwds)      
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "Array" usage = "
#   Returns a synchronized shared array
#">                                
# -------------------------------------------------------------------------------------------------
def Array(typecode_or_type, size_or_initializer, **kwds):
    '''
    Returns a synchronized shared array
    '''
    from multiprocessing.sharedctypes import Array
    return Array(typecode_or_type, size_or_initializer, **kwds)
#</function4xi>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "ArrayFunction2Xi" usage = "
#   Returns a synchronized shared array
#">                                
# -------------------------------------------------------------------------------------------------
def ArrayFunction2Xi(typecode_or_type, size_or_initializer, **kwds):
    '''
    Returns a synchronized shared array
    '''
    from arrayfunction2xi import ArrayFunction2Xi
    return ArrayFunction2Xi(typecode_or_type, size_or_initializer, **kwds)    
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "ArrayFunction4Xi" usage = "
#   Returns a synchronized shared array
#">                                
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def ArrayFunction4Xi(typecode_or_type, size_or_initializer, **kwds):
    '''
    Returns a synchronized shared array
    '''
    from arrayfunction4xi import ArrayFunction4Xi
    return ArrayFunction4Xi(typecode_or_type, size_or_initializer, **kwds)      
#</function4xi>
        
    
# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
#
#
#
if sys.platform == 'win32':

    # ---------------------------------------------------------------------------------------------
    #<function4xi function = "set_executable" usage = "
    #   Sets the path to a python.exe or pythonw.exe binary used to run child processes on Windows
    #">                                
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    
    def set_executable(executable):
        '''
        Sets the path to a python.exe or pythonw.exe binary used to run
        child processes on Windows instead of sys.executable.
        Useful for people embedding Python.
        '''
        from multiprocessing.forking import set_executable
        set_executable(executable)
    #</function4xi>

    __all__ += ['set_executable']

    # ---------------------------------------------------------------------------------------------
    #<function4xi function = "set_executable2xi" usage = "
    #   Sets the path to a python.exe or pythonw.exe binary used to run child processes on Windows
    #">                                
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
        
    def set_executable2xi(executable):
        set_executable(executable)

    __all__ += ['set_executable2xi']
    #</function4xi>

    # ---------------------------------------------------------------------------------------------
    #<function4xi function = "set_executable4xi" usage = "
    #   Sets the path to a python.exe or pythonw.exe binary used to run child processes on Windows
    #   Is embedded inside popen4xi.py
    #">                                
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
        
    def set_executable4xi(executable):
        set_executable(executable)

    __all__ += ['set_executable4xi']
    #</function4xi>
        


#</program4xi>
    
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#
#   test_*xi4.py.txt
#   sense-*4xi.xml
#   reason-*4xi.xml
#   ace-*4xi.xml
# 
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of __init__.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>


